Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.Designer.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.Designer.cs	(revision 5647)
+++ 	(revision )
@@ -1,130 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Clients.OKB.RunCreation {
-  partial class OKBProblemView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing) {
-        if (components != null) components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.problemLabel = new System.Windows.Forms.Label();
-      this.problemComboBox = new System.Windows.Forms.ComboBox();
-      this.refreshButton = new System.Windows.Forms.Button();
-      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.SuspendLayout();
-      // 
-      // problemLabel
-      // 
-      this.problemLabel.AutoSize = true;
-      this.problemLabel.Location = new System.Drawing.Point(3, 5);
-      this.problemLabel.Name = "problemLabel";
-      this.problemLabel.Size = new System.Drawing.Size(48, 13);
-      this.problemLabel.TabIndex = 0;
-      this.problemLabel.Text = "&Problem:";
-      // 
-      // problemComboBox
-      // 
-      this.problemComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.problemComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.problemComboBox.FormattingEnabled = true;
-      this.problemComboBox.Location = new System.Drawing.Point(57, 1);
-      this.problemComboBox.Name = "problemComboBox";
-      this.problemComboBox.Size = new System.Drawing.Size(551, 21);
-      this.problemComboBox.TabIndex = 1;
-      this.problemComboBox.SelectedValueChanged += new System.EventHandler(this.problemComboBox_SelectedValueChanged);
-      // 
-      // refreshButton
-      // 
-      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.refreshButton.Location = new System.Drawing.Point(614, 0);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 2;
-      this.toolTip.SetToolTip(this.refreshButton, "Refresh Problems");
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
-      // viewHost
-      // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.viewHost.Caption = "View";
-      this.viewHost.Content = null;
-      this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(0, 30);
-      this.viewHost.Name = "viewHost";
-      this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(638, 422);
-      this.viewHost.TabIndex = 3;
-      this.viewHost.ViewsLabelVisible = true;
-      this.viewHost.ViewType = null;
-      // 
-      // OKBProblemView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.viewHost);
-      this.Controls.Add(this.problemComboBox);
-      this.Controls.Add(this.problemLabel);
-      this.Controls.Add(this.refreshButton);
-      this.Name = "OKBProblemView";
-      this.Size = new System.Drawing.Size(638, 452);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.Label problemLabel;
-    private System.Windows.Forms.ComboBox problemComboBox;
-    private System.Windows.Forms.Button refreshButton;
-    private System.Windows.Forms.ToolTip toolTip;
-    private MainForm.WindowsForms.ViewHost viewHost;
-
-
-
-
-  }
-}
Index: branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.cs	(revision 5647)
+++ 	(revision )
@@ -1,129 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
-
-namespace HeuristicLab.Clients.OKB.RunCreation {
-  [View("OKBProblem View")]
-  [Content(typeof(OKBProblem), true)]
-  public sealed partial class OKBProblemView : ItemView {
-    public new OKBProblem Content {
-      get { return (OKBProblem)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public OKBProblemView() {
-      InitializeComponent();
-    }
-
-    protected override void OnInitialized(System.EventArgs e) {
-      base.OnInitialized(e);
-      RunCreationClient.Instance.Refreshing += new EventHandler(RunCreationClient_Refreshing);
-      RunCreationClient.Instance.Refreshed += new EventHandler(RunCreationClient_Refreshed);
-      PopulateComboBox();
-    }
-
-    protected override void DeregisterContentEvents() {
-      Content.ProblemChanged -= new EventHandler(Content_ProblemChanged);
-      base.DeregisterContentEvents();
-    }
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ProblemChanged += new EventHandler(Content_ProblemChanged);
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        problemComboBox.SelectedIndex = -1;
-        viewHost.Content = null;
-      } else {
-        problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
-        viewHost.Content = Content.Problem;
-      }
-    }
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      problemComboBox.Enabled = (Content != null) && !ReadOnly && !Locked && (problemComboBox.Items.Count > 0);
-      refreshButton.Enabled = (Content != null) && !ReadOnly && !Locked;
-    }
-
-    private void PopulateComboBox() {
-      problemComboBox.DataSource = null;
-      problemComboBox.DataSource = RunCreationClient.Instance.Problems.ToList();
-      problemComboBox.DisplayMember = "Name";
-    }
-
-    protected override void OnClosed(FormClosedEventArgs e) {
-      RunCreationClient.Instance.Refreshing -= new EventHandler(RunCreationClient_Refreshing);
-      RunCreationClient.Instance.Refreshed -= new EventHandler(RunCreationClient_Refreshed);
-      base.OnClosed(e);
-    }
-
-    private void RunCreationClient_Refreshing(object sender, EventArgs e) {
-      if (InvokeRequired) {
-        Invoke(new EventHandler(RunCreationClient_Refreshing), sender, e);
-      } else {
-        Cursor = Cursors.AppStarting;
-        problemComboBox.Enabled = refreshButton.Enabled = viewHost.Enabled = false;
-      }
-    }
-    private void RunCreationClient_Refreshed(object sender, EventArgs e) {
-      if (InvokeRequired) {
-        Invoke(new EventHandler(RunCreationClient_Refreshed), sender, e);
-      } else {
-        PopulateComboBox();
-        SetEnabledStateOfControls();
-        Cursor = Cursors.Default;
-      }
-    }
-
-    #region Content Events
-    private void Content_ProblemChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_ProblemChanged), sender, e);
-      else {
-        problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
-        viewHost.Content = Content.Problem;
-      }
-    }
-    #endregion
-
-    #region Control Events
-    private void refreshButton_Click(object sender, System.EventArgs e) {
-      RunCreationClient.Instance.Refresh();
-    }
-    private void problemComboBox_SelectedValueChanged(object sender, System.EventArgs e) {
-      Problem problem = problemComboBox.SelectedValue as Problem;
-      if ((problem != null) && (Content != null)) {
-        Content.Load(problem.Id);
-        if (Content.ProblemId != problem.Id)  // reset selected item if load was not successful
-          problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
-      }
-    }
-    #endregion
-  }
-}