Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5659)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5660)
@@ -305,9 +305,9 @@
       <DependentUpon>OKBAlgorithmView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCreation\Views\ProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="RunCreation\Views\ProblemView.Designer.cs">
-      <DependentUpon>ProblemView.cs</DependentUpon>
+    <Compile Include="RunCreation\Views\OKBProblemView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="RunCreation\Views\OKBProblemView.Designer.cs">
+      <DependentUpon>OKBProblemView.cs</DependentUpon>
     </Compile>
     <None Include="app.config" />
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.Designer.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.Designer.cs	(revision 5659)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.Designer.cs	(revision 5660)
@@ -57,4 +57,5 @@
       this.algorithmLabel = new System.Windows.Forms.Label();
       this.refreshButton = new System.Windows.Forms.Button();
+      this.cloneAlgorithmButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.tabControl.SuspendLayout();
@@ -71,15 +72,15 @@
       this.nameTextBox.Location = new System.Drawing.Point(72, 29);
       this.nameTextBox.Size = new System.Drawing.Size(607, 20);
-      this.nameTextBox.TabIndex = 4;
+      this.nameTextBox.TabIndex = 5;
       // 
       // nameLabel
       // 
       this.nameLabel.Location = new System.Drawing.Point(3, 32);
-      this.nameLabel.TabIndex = 3;
+      this.nameLabel.TabIndex = 4;
       // 
       // descriptionLabel
       // 
       this.descriptionLabel.Location = new System.Drawing.Point(3, 58);
-      this.descriptionLabel.TabIndex = 5;
+      this.descriptionLabel.TabIndex = 6;
       // 
       // descriptionTextBox
@@ -87,5 +88,5 @@
       this.descriptionTextBox.Location = new System.Drawing.Point(72, 55);
       this.descriptionTextBox.Size = new System.Drawing.Size(607, 20);
-      this.descriptionTextBox.TabIndex = 6;
+      this.descriptionTextBox.TabIndex = 7;
       // 
       // tabControl
@@ -103,5 +104,5 @@
       this.tabControl.SelectedIndex = 0;
       this.tabControl.Size = new System.Drawing.Size(679, 371);
-      this.tabControl.TabIndex = 7;
+      this.tabControl.TabIndex = 8;
       // 
       // problemTabPage
@@ -256,5 +257,5 @@
       this.startButton.Name = "startButton";
       this.startButton.Size = new System.Drawing.Size(24, 24);
-      this.startButton.TabIndex = 8;
+      this.startButton.TabIndex = 9;
       this.toolTip.SetToolTip(this.startButton, "Start/Resume Algorithm");
       this.startButton.UseVisualStyleBackColor = true;
@@ -268,5 +269,5 @@
       this.pauseButton.Name = "pauseButton";
       this.pauseButton.Size = new System.Drawing.Size(24, 24);
-      this.pauseButton.TabIndex = 9;
+      this.pauseButton.TabIndex = 10;
       this.toolTip.SetToolTip(this.pauseButton, "Pause Algorithm");
       this.pauseButton.UseVisualStyleBackColor = true;
@@ -280,5 +281,5 @@
       this.resetButton.Name = "resetButton";
       this.resetButton.Size = new System.Drawing.Size(24, 24);
-      this.resetButton.TabIndex = 11;
+      this.resetButton.TabIndex = 12;
       this.toolTip.SetToolTip(this.resetButton, "Reset Algorithm");
       this.resetButton.UseVisualStyleBackColor = true;
@@ -292,5 +293,5 @@
       this.executionTimeLabel.Name = "executionTimeLabel";
       this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
-      this.executionTimeLabel.TabIndex = 12;
+      this.executionTimeLabel.TabIndex = 13;
       this.executionTimeLabel.Text = "&Execution Time:";
       // 
@@ -302,5 +303,5 @@
       this.executionTimeTextBox.ReadOnly = true;
       this.executionTimeTextBox.Size = new System.Drawing.Size(137, 20);
-      this.executionTimeTextBox.TabIndex = 13;
+      this.executionTimeTextBox.TabIndex = 14;
       // 
       // openFileDialog
@@ -318,5 +319,5 @@
       this.stopButton.Name = "stopButton";
       this.stopButton.Size = new System.Drawing.Size(24, 24);
-      this.stopButton.TabIndex = 10;
+      this.stopButton.TabIndex = 11;
       this.toolTip.SetToolTip(this.stopButton, "Stop Algorithm");
       this.stopButton.UseVisualStyleBackColor = true;
@@ -331,5 +332,5 @@
       this.algorithmComboBox.Location = new System.Drawing.Point(72, 0);
       this.algorithmComboBox.Name = "algorithmComboBox";
-      this.algorithmComboBox.Size = new System.Drawing.Size(577, 21);
+      this.algorithmComboBox.Size = new System.Drawing.Size(547, 21);
       this.algorithmComboBox.TabIndex = 1;
       this.algorithmComboBox.SelectedValueChanged += new System.EventHandler(this.algorithmComboBox_SelectedValueChanged);
@@ -351,10 +352,22 @@
       this.refreshButton.Name = "refreshButton";
       this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 2;
+      this.refreshButton.TabIndex = 3;
       this.toolTip.SetToolTip(this.refreshButton, "Refresh Algorithms");
       this.refreshButton.UseVisualStyleBackColor = true;
       this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
       // 
-      // AlgorithmView
+      // cloneAlgorithmButton
+      // 
+      this.cloneAlgorithmButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.cloneAlgorithmButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Clone;
+      this.cloneAlgorithmButton.Location = new System.Drawing.Point(625, -1);
+      this.cloneAlgorithmButton.Name = "cloneAlgorithmButton";
+      this.cloneAlgorithmButton.Size = new System.Drawing.Size(24, 24);
+      this.cloneAlgorithmButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.cloneAlgorithmButton, "Clone Algorithm");
+      this.cloneAlgorithmButton.UseVisualStyleBackColor = true;
+      this.cloneAlgorithmButton.Click += new System.EventHandler(this.cloneAlgorithmButton_Click);
+      // 
+      // OKBAlgorithmView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -362,4 +375,5 @@
       this.Controls.Add(this.algorithmComboBox);
       this.Controls.Add(this.algorithmLabel);
+      this.Controls.Add(this.cloneAlgorithmButton);
       this.Controls.Add(this.refreshButton);
       this.Controls.Add(this.tabControl);
@@ -370,5 +384,5 @@
       this.Controls.Add(this.stopButton);
       this.Controls.Add(this.resetButton);
-      this.Name = "AlgorithmView";
+      this.Name = "OKBAlgorithmView";
       this.Size = new System.Drawing.Size(679, 482);
       this.Controls.SetChildIndex(this.resetButton, 0);
@@ -384,4 +398,5 @@
       this.Controls.SetChildIndex(this.tabControl, 0);
       this.Controls.SetChildIndex(this.refreshButton, 0);
+      this.Controls.SetChildIndex(this.cloneAlgorithmButton, 0);
       this.Controls.SetChildIndex(this.algorithmLabel, 0);
       this.Controls.SetChildIndex(this.algorithmComboBox, 0);
@@ -422,4 +437,5 @@
     private System.Windows.Forms.Label algorithmLabel;
     private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button cloneAlgorithmButton;
   }
 }
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.cs	(revision 5659)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBAlgorithmView.cs	(revision 5660)
@@ -124,4 +124,5 @@
       base.SetEnabledStateOfControls();
       algorithmComboBox.Enabled = (Content != null) && !ReadOnly && !Locked && (algorithmComboBox.Items.Count > 0);
+      cloneAlgorithmButton.Enabled = (Content != null) && (Content.Problem != null) && !ReadOnly && !Locked;
       refreshButton.Enabled = (Content != null) && !ReadOnly && !Locked;
       parameterCollectionView.Enabled = Content != null;
@@ -246,4 +247,7 @@
 
     #region Control Events
+    private void cloneAlgorithmButton_Click(object sender, EventArgs e) {
+      MainFormManager.MainForm.ShowContent((IContent)Content.Algorithm.Clone());
+    }
     private void refreshButton_Click(object sender, System.EventArgs e) {
       RunCreationClient.Instance.Refresh();
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.Designer.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.Designer.cs	(revision 5660)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.Designer.cs	(revision 5660)
@@ -0,0 +1,171 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB.RunCreation {
+  partial class OKBProblemView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.problemComboBox = new System.Windows.Forms.ComboBox();
+      this.problemLabel = new System.Windows.Forms.Label();
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.cloneProblemButton = new System.Windows.Forms.Button();
+      this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // parameterCollectionView
+      // 
+      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.parameterCollectionView.Content = null;
+      this.parameterCollectionView.Location = new System.Drawing.Point(0, 79);
+      this.parameterCollectionView.Name = "parameterCollectionView";
+      this.parameterCollectionView.Size = new System.Drawing.Size(706, 314);
+      this.parameterCollectionView.TabIndex = 8;
+      // 
+      // nameTextBox
+      // 
+      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
+      this.nameTextBox.Location = new System.Drawing.Point(72, 27);
+      this.nameTextBox.Size = new System.Drawing.Size(634, 20);
+      this.nameTextBox.TabIndex = 5;
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.Location = new System.Drawing.Point(3, 30);
+      this.nameLabel.TabIndex = 4;
+      // 
+      // descriptionLabel
+      // 
+      this.descriptionLabel.Location = new System.Drawing.Point(3, 56);
+      this.descriptionLabel.TabIndex = 6;
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Location = new System.Drawing.Point(72, 53);
+      this.descriptionTextBox.Size = new System.Drawing.Size(634, 20);
+      this.descriptionTextBox.TabIndex = 7;
+      // 
+      // problemComboBox
+      // 
+      this.problemComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.problemComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.problemComboBox.FormattingEnabled = true;
+      this.problemComboBox.Location = new System.Drawing.Point(72, 0);
+      this.problemComboBox.Name = "problemComboBox";
+      this.problemComboBox.Size = new System.Drawing.Size(574, 21);
+      this.problemComboBox.TabIndex = 1;
+      this.problemComboBox.SelectedValueChanged += new System.EventHandler(this.problemComboBox_SelectedValueChanged);
+      // 
+      // problemLabel
+      // 
+      this.problemLabel.AutoSize = true;
+      this.problemLabel.Location = new System.Drawing.Point(3, 3);
+      this.problemLabel.Name = "problemLabel";
+      this.problemLabel.Size = new System.Drawing.Size(48, 13);
+      this.problemLabel.TabIndex = 0;
+      this.problemLabel.Text = "&Problem:";
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.refreshButton.Location = new System.Drawing.Point(682, -1);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 3;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh Problems");
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // cloneProblemButton
+      // 
+      this.cloneProblemButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.cloneProblemButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Clone;
+      this.cloneProblemButton.Location = new System.Drawing.Point(652, -1);
+      this.cloneProblemButton.Name = "cloneProblemButton";
+      this.cloneProblemButton.Size = new System.Drawing.Size(24, 24);
+      this.cloneProblemButton.TabIndex = 2;
+      this.toolTip.SetToolTip(this.cloneProblemButton, "Clone Problem");
+      this.cloneProblemButton.UseVisualStyleBackColor = true;
+      this.cloneProblemButton.Click += new System.EventHandler(this.cloneProblemButton_Click);
+      // 
+      // OKBProblemView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.problemComboBox);
+      this.Controls.Add(this.problemLabel);
+      this.Controls.Add(this.cloneProblemButton);
+      this.Controls.Add(this.refreshButton);
+      this.Controls.Add(this.parameterCollectionView);
+      this.Name = "OKBProblemView";
+      this.Size = new System.Drawing.Size(706, 393);
+      this.Controls.SetChildIndex(this.refreshButton, 0);
+      this.Controls.SetChildIndex(this.cloneProblemButton, 0);
+      this.Controls.SetChildIndex(this.problemLabel, 0);
+      this.Controls.SetChildIndex(this.descriptionLabel, 0);
+      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
+      this.Controls.SetChildIndex(this.nameTextBox, 0);
+      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
+      this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.problemComboBox, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.ComboBox problemComboBox;
+    private System.Windows.Forms.Label problemLabel;
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button cloneProblemButton;
+    private HeuristicLab.Core.Views.ParameterCollectionView parameterCollectionView;
+
+
+  }
+}
Index: /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.cs	(revision 5660)
+++ /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/OKBProblemView.cs	(revision 5660)
@@ -0,0 +1,136 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.OKB.RunCreation {
+  [View("OKBProblem View")]
+  [Content(typeof(OKBProblem), true)]
+  public partial class OKBProblemView : NamedItemView {
+    public new OKBProblem Content {
+      get { return (OKBProblem)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public OKBProblemView() {
+      InitializeComponent();
+    }
+
+    protected override void OnInitialized(System.EventArgs e) {
+      base.OnInitialized(e);
+      RunCreationClient.Instance.Refreshing += new EventHandler(RunCreationClient_Refreshing);
+      RunCreationClient.Instance.Refreshed += new EventHandler(RunCreationClient_Refreshed);
+      PopulateComboBox();
+    }
+
+    protected override void DeregisterContentEvents() {
+      Content.ProblemChanged -= new EventHandler(Content_ProblemChanged);
+      base.DeregisterContentEvents();
+    }
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ProblemChanged += new EventHandler(Content_ProblemChanged);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        problemComboBox.SelectedIndex = -1;
+        parameterCollectionView.Content = null;
+      } else {
+        problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
+        parameterCollectionView.Content = Content.Parameters;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      problemComboBox.Enabled = (Content != null) && !ReadOnly && !Locked && (problemComboBox.Items.Count > 0);
+      cloneProblemButton.Enabled = (Content != null) && (Content.Problem != null) && !ReadOnly && !Locked;
+      refreshButton.Enabled = (Content != null) && !ReadOnly && !Locked;
+      parameterCollectionView.Enabled = Content != null;
+    }
+
+    protected override void OnClosed(FormClosedEventArgs e) {
+      RunCreationClient.Instance.Refreshing -= new EventHandler(RunCreationClient_Refreshing);
+      RunCreationClient.Instance.Refreshed -= new EventHandler(RunCreationClient_Refreshed);
+      base.OnClosed(e);
+    }
+
+    private void RunCreationClient_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(RunCreationClient_Refreshing), sender, e);
+      } else {
+        Cursor = Cursors.AppStarting;
+        problemComboBox.Enabled = refreshButton.Enabled = false;
+      }
+    }
+    private void RunCreationClient_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(RunCreationClient_Refreshed), sender, e);
+      } else {
+        PopulateComboBox();
+        SetEnabledStateOfControls();
+        Cursor = Cursors.Default;
+      }
+    }
+
+    #region Content Events
+    private void Content_ProblemChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_ProblemChanged), sender, e);
+      else {
+        problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
+      }
+    }
+    #endregion
+
+    #region Control Events
+    private void cloneProblemButton_Click(object sender, EventArgs e) {
+      MainFormManager.MainForm.ShowContent((IContent)Content.Problem.Clone());
+    }
+    private void refreshButton_Click(object sender, System.EventArgs e) {
+      RunCreationClient.Instance.Refresh();
+    }
+    private void problemComboBox_SelectedValueChanged(object sender, System.EventArgs e) {
+      Problem problem = problemComboBox.SelectedValue as Problem;
+      if ((problem != null) && (Content != null)) {
+        Content.Load(problem.Id);
+        if (Content.ProblemId != problem.Id)  // reset selected item if load was not successful
+          problemComboBox.SelectedItem = RunCreationClient.Instance.Problems.FirstOrDefault(x => x.Id == Content.ProblemId);
+      }
+    }
+    #endregion
+
+    #region Helpers
+    private void PopulateComboBox() {
+      problemComboBox.DataSource = null;
+      problemComboBox.DataSource = RunCreationClient.Instance.Problems.ToList();
+      problemComboBox.DisplayMember = "Name";
+    }
+    #endregion
+  }
+}
Index: anches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/ProblemView.Designer.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/ProblemView.Designer.cs	(revision 5659)
+++ 	(revision )
@@ -1,104 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Clients.OKB.RunCreation {
-  partial class OKBProblemView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing) {
-        if (components != null) components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.problemComboBox = new System.Windows.Forms.ComboBox();
-      this.problemLabel = new System.Windows.Forms.Label();
-      this.refreshButton = new System.Windows.Forms.Button();
-      this.SuspendLayout();
-      // 
-      // problemComboBox
-      // 
-      this.problemComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.problemComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.problemComboBox.FormattingEnabled = true;
-      this.problemComboBox.Location = new System.Drawing.Point(57, 0);
-      this.problemComboBox.Name = "problemComboBox";
-      this.problemComboBox.Size = new System.Drawing.Size(619, 21);
-      this.problemComboBox.TabIndex = 4;
-      // 
-      // problemLabel
-      // 
-      this.problemLabel.AutoSize = true;
-      this.problemLabel.Location = new System.Drawing.Point(3, 3);
-      this.problemLabel.Name = "problemLabel";
-      this.problemLabel.Size = new System.Drawing.Size(48, 13);
-      this.problemLabel.TabIndex = 3;
-      this.problemLabel.Text = "&Problem:";
-      // 
-      // refreshButton
-      // 
-      this.refreshButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.refreshButton.Location = new System.Drawing.Point(682, -1);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 5;
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
-      // 
-      // OKBProblemView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.problemComboBox);
-      this.Controls.Add(this.problemLabel);
-      this.Controls.Add(this.refreshButton);
-      this.Name = "OKBProblemView";
-      this.Size = new System.Drawing.Size(706, 393);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.ComboBox problemComboBox;
-    private System.Windows.Forms.Label problemLabel;
-    private System.Windows.Forms.Button refreshButton;
-
-
-  }
-}
Index: anches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/ProblemView.cs
===================================================================
--- /branches/OKB (trunk integration)/HeuristicLab.Clients.OKB/3.3/RunCreation/Views/ProblemView.cs	(revision 5659)
+++ 	(revision )
@@ -1,46 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Clients.OKB.RunCreation {
-  [View("OKBProblem View")]
-  [Content(typeof(OKBProblem), true)]
-  public partial class OKBProblemView : ParameterizedNamedItemView {
-    public new OKBProblem Content {
-      get { return (OKBProblem)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public OKBProblemView() {
-      InitializeComponent();
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-    }
-
-    private void refreshButton_Click(object sender, System.EventArgs e) {
-
-    }
-  }
-}